import * as prismic from "@prismicio/client";
import * as cookie from "cookie";
import { c as createClient } from "../../../chunks/prismicio.js";
async function GET(params) {
  const { url, request } = params;
  const client = createClient({ fetch, request });
  const previewToken = url.searchParams.get("token");
  const previewURL = await client.resolvePreviewURL({ defaultURL: "/" });
  const response = new Response(null, {
    status: 302,
    headers: {
      "set-cookie": cookie.serialize(prismic.cookie.preview, previewToken, { path: "/" }),
      location: "https://localhost:5173" + previewURL
    }
  });
  console.log("Redirect");
  return response;
}
export {
  GET
};
